unit hiHotKeys;

interface

uses kol,windows,Messages,Share,Debug;

var
  GCount:integer=1;
  GKeysList:PStrList;

type
  THIHotKeys = class(TDebug)
   private
    FKeysList:PStrList;
    FCount:integer;
    FIdxArr:integer;
    FNewEvent:integer;
    FArrID: array [0..99] of integer; //ATOM;
    FErr:string;
    dt:TData;
    pc:PControl;
    FAuto:integer;
    FTimer:PTimer;

   procedure SetText(const Value:string);
   procedure SetCount(Value:integer);
   procedure Auto(Value:integer);
   function  _onMsgHotKey(var Msg: TMsg; var Rslt: Integer ):Boolean;
   procedure AddHotKeys(formatkey:string);
   procedure RegisterHotKeys(id:integer);
   procedure UnregisterHotKeys(id:integer);
   procedure OnTimer(Obj:PObj);

   public
    onHotKeys:array of THI_Event;

    constructor Create;
    destructor Destroy; override;

    procedure _work_doActivateHotKeys(var _Data:TData; Index:word);
    procedure _work_doDeactivateHotKeys(var _Data:TData; Index:word);
    procedure _work_doKeysList(var _Data:TData; Index:word);
    procedure _var_Error(var _Data:TData; Index:word);
    procedure _var_FormatHotKeys(var _Data:TData; Index:word);
    procedure _var_ListHotKeys(var _Data:TData; Index:word);
    procedure _var_Keys(var _Data:TData; Index:word);

    property _prop_KeysList:string write SetText;
    property _prop_Count:integer write SetCount;
    property _prop_AutoActivate:integer write Auto;

  end;

implementation

//MOD_ALT     = 1;
//MOD_CONTROL = 2;
//MOD_SHIFT   = 4;
//MOD_WIN     = 8;

function Trim(inStr:string): string;
var
  lnint:integer;
  sTmp:string;
begin
  sTmp := inStr;
  lnint := Length(inStr);
  while (lnint > 0) and (sTmp[lnint] = ' ') do dec(lnint);
  SetLength(sTmp, lnint);
  lnint := 1;
  while (lnint <= Length(sTmp)) and (sTmp[lnint] = ' ') do inc(lnint);
  Result := string(PChar(integer(@sTmp[1]) + lnint - 1));
end;

function GetKeyName(Code: Integer): string;
var
  KeyName: array[0..255] of Char;
begin
  result := '';
  Code := MapVirtualKey(Code, 0);
  if Code <> 0 then
    if GetKeyNameText(Code shl 16, KeyName, SizeOf(KeyName)) > 0 then
      Result := KeyName;
end;

procedure InitStrlistkey;
var
  i:integer;
begin
  for i := 0 to 255 do
    GKeysList.Add(GetKeyName(i));
end;

procedure Explode(var a: array of string; Border, S: string; var Count: integer);
var
  S2: string;
  i: Integer;
begin
  //SetLength(a,10);
  i  := 0;
  S2 := S + Border;
  repeat
    a[i] := Copy(S2, 0,Pos(Border, S2) - 1);
    Delete(S2, 1,Length(a[i] + Border));
    Inc(i);
  until S2 = '';
  Count := i;
end;

function FrmSysKey(inFlags:word):string;
begin
 Result := '';
  case inFlags of
   {None             }0: Exit;
   {ALT              }1: Result := 'Alt + ';
   {CONTROL          }2: Result := 'Ctrl + ';
   {SHIFT            }4: Result := 'Shift + ';
   {CONTROL+ALT      }3: Result := 'Ctrl + Alt + ';
   {CONTROL+SHIFT    }6: Result := 'Ctrl + Shift + ';
   {SHIFT+ALT        }5: Result := 'Shift + Alt + ';
   {CONTROL+SHIFT+ALT}7: Result := 'Ctrl + Shift + Alt + ';
  end;
end;

procedure THIHotKeys.SetCount;
begin
  SetLength(onHotKeys,Value);
end;

procedure THIHotKeys.Auto;
begin
  FAuto := Value;
  //if FAuto = 1 then RegisterHotKeys(-1);
end;

procedure THIHotKeys.SetText;
begin
   FKeysList.SetText(Value, false);
   FCount := FKeysList.Count;
end;

procedure THIHotKeys.OnTimer(Obj:PObj);
begin
  if FAuto = 1 then RegisterHotKeys(-1);
end;

constructor THIHotKeys.Create;
begin
   inherited Create;
   FTimer := NewTimer(100);
   FTimer.Enabled := True;
   FTimer.OnTimer := onTimer;

   SetLength(onHotKeys,0);
   FKeysList := NewStrList;
   pc := NewLabel(Applet,'');
   pc.visible := True;
   pc.onMessage := _onMsgHotKey;
end;

destructor THIHotKeys.Destroy;
begin
   UnregisterHotKeys(-1);
   FKeysList.Free;
   SetLength(onHotKeys,0);
   inherited Destroy;
end;

procedure THIHotKeys.AddHotKeys(formatkey:string);
var stmp:string;
    sArr: array [0..9] of string;
    i,sk,idx,count:integer;
    _SK_,Key:word;
begin
  FTimer.Enabled := False;
  _SK_ := 0; Key := 0;
  stmp := formatkey;
  Explode(sArr, ';', stmp, count);
  stmp := sArr[0]; sArr[1] := '';
  Explode(sArr, '+', stmp, count);

  for i :=0 to Count-1 do
  begin
    stmp := Trim(sArr[i]);
    idx :=  GKeysList.IndexOf(stmp);
    case idx of
 { ALT   } 16: begin _SK_ := (_SK_ or MOD_SHIFT); inc(sk); end;
 { CTRL  } 17: begin _SK_ := (_SK_ or MOD_CONTROL); inc(sk);end;
 { SHIFT } 18: begin _SK_ := (_SK_ or MOD_ALT); inc(sk); end;
 { WIN   } //   ??? begin _SK_ := (_SK_ or MOD_WIN); end;
    else
      Key := idx;
    end;

    if Count = sk then
      begin
        FErr := FErr + 'Error idx: ' + Int2Str(FIdxArr) + #13#10;
        inc(GCount);
        Exit;
      end;
  end;
  FArrID[FIdxArr] := GlobalAddAtom(PChar('KeyID:' + Int2Str(GCount)));
  RegisterHotKey(pc.Handle, FArrID[FIdxArr], _SK_, Key);
  inc(GCount); inc(FIdxArr);
end;

procedure THIHotKeys.UnregisterHotKeys(id:integer);
var
  idx:integer;
begin
  if id = -1 then
   for idx := 0 to FKeysList.Count -1 do
     begin
       UnregisterHotKey(pc.Handle, FArrID[idx]);
       GlobalDeleteAtom(FArrID[idx]);
       FIdxArr := 0;
     end
  else
    begin
      UnregisterHotKey(pc.Handle, FArrID[id]);
      GlobalDeleteAtom(FArrID[id]);
    end;
end;

procedure THIHotKeys.RegisterHotKeys(id:integer);
var
  idx:integer;
begin
  if id = -1 then
   for idx := 0 to FKeysList.Count -1 do
     begin
       AddHotKeys(FKeysList.Items[idx]);
     end
   else
     begin
       AddHotKeys(FKeysList.Items[id]);
     end;
end;

function THIHotKeys._onMsgHotKey;
var
  idHotKey,i: integer;
begin
  case Msg.message of
    WM_HOTKEY:
    begin
      idHotkey:= Msg.wParam;
      for i := 0 to FKeysList.Count -1 do
        begin
          if idHotkey = FArrID[i] then
            begin
              FNewEvent := i;
              //_hi_CreateEvent_(dt,@onHotKeys[i+1]);
              _hi_onEvent(onHotKeys[i], '');
            end;
        end;
 end;
  end;
  Result := False;
end;

procedure THIHotKeys._work_doKeysList;
var
  stmp:string;
begin
  stmp := ToString(_Data);
  UnregisterHotKeys(-1);
  FKeysList.Clear;
  FKeysList.SetText(stmp, false);
  if FAuto = 1 then RegisterHotKeys(-1);
end;

procedure THIHotKeys._work_doActivateHotKeys;
var idx:integer;
begin
  idx := ToInteger(_Data);
  RegisterHotKeys(idx);
end;

procedure THIHotKeys._work_doDeactivateHotKeys;
var idx:integer;
begin
  idx := ToInteger(_Data);
  UnregisterHotKeys(idx);;
end;

procedure THIHotKeys._var_FormatHotKeys;
var
  i:integer;
  stmp,Key: string;
  _SK_:word;
begin
  _SK_ := 0;
  for i := 1 to 255 do
  begin
    if GetAsyncKeyState(i) < 0 then
    //if GetKeyState(i) < 0 then
    begin
      case i of
        16: _SK_ := (_SK_ or MOD_SHIFT);
        17: _SK_ := (_SK_ or MOD_CONTROL);
        18: _SK_ := (_SK_ or MOD_ALT);
        160..165:;
      else
        Key := GetKeyName(i);
      end;
    end;
  end;
  stmp := FrmSysKey(_SK_) + Key;
  dtString(_Data, stmp);
end;

procedure THIHotKeys._var_Error;
begin
  dtString(_Data, FErr);
end;

procedure THIHotKeys._var_ListHotKeys;
begin
  dtString(_Data, FKeysList.Text);
end;

procedure THIHotKeys._var_Keys;
var
  sArr: array [0..2] of string;
  sTmp:string;
  count:integer;
begin
  sTmp := FKeysList.Items[FNewEvent];
  Explode(sArr, ';', stmp, count);
  sTmp := sArr[0];
  dtString(_Data, sTmp);
end;

initialization
  GKeysList := NewStrList;
  InitStrlistkey;

finalization
   GKeysList.Free;


end.
